-- Move and Attack AI: Fire Closest

-- Moves to within range of the target, and fires missile weapons at it
ai.new
{
	name	= "FIRE_CLOSEST"
	state	=
	{
		MIN_RANGE = 1
		BEST_RANGE = 1
	}
	exec	= function(m_idx, monst, state)
		local range = monst.flags[FLAG_MONST_BASE_RANGE]
		local y, x = ai.target(monst)
		local dist = ai.distance(monst)

		if dist > range then
			monst.ai_action = ai.action.MOVE
			monst.ai_move_y = y
			monst.ai_move_x = x
		elseif monst.flags[FLAG_MONST_AMMO_CURRENT] > 0  then
			if los(y, x, monst.fy, monst.fx) then
				local c_ptr = cave(y, x)
				local m_ptr = monster(m_idx)
				local t_idx = c_ptr.m_idx
				local t_ptr = player

					-- Get the monster if it is a monster
				if c_ptr.m_idx > 0 then
					t_ptr = monster(t_idx)
				end

				local t_flags = t_ptr.intrinsic_flags or t_ptr.flags

				-- Give this info to the monster attack system, and force it
				-- to attack
				combat_monster.attack(y, x, c_ptr, m_idx, m_ptr, t_idx, t_ptr, t_flags)

				-- Cannot attack and then move, so stop from moving
				monst.ai_action = ai.action.REST

			else
			-- it has no line of site, try and move into LOS
				monst.ai_action = ai.action.MOVE
				monst.ai_move_y = y
				monst.ai_move_x = x
			end
		else
		-- just move in and attack
			monst.ai_action = ai.action.MOVE
			monst.ai_move_y = y
			monst.ai_move_x = x
		end
	end
}